import{ObjectWrapper as e,Color as t,ColorUtils as s,Linkifier as i}from"../common/common.js";import{SDKModel as n,CSSModel as o,DOMModel as a}from"../sdk/sdk.js";import{ContrastInfo as r}from"../color_picker/color_picker.js";import{Runtime as l}from"../root/root.js";import{Widget as d,UIUtils as c,Fragment as h,Toolbar as u,Panel as m,SplitWidget as v,TabbedPane as p,Icon as _,Tooltip as g}from"../ui/ui.js";import{Linkifier as b}from"../components/components.js";import{SortableDataGrid as f,DataGrid as C}from"../data_grid/data_grid.js";import{TextRange as w}from"../text_utils/text_utils.js";import{userMetrics as S,UserMetrics as y}from"../host/host.js";class $ extends e.ObjectWrapper{constructor(){super(),this.currentUrl=n.TargetManager.instance().inspectedURL(),n.TargetManager.instance().addEventListener(n.Events.InspectedURLChanged,this._checkUrlAndResetIfChanged,this)}_checkUrlAndResetIfChanged(){this.currentUrl!==n.TargetManager.instance().inspectedURL()&&(this.currentUrl=n.TargetManager.instance().inspectedURL(),this.dispatchEventToListeners(I.Reset))}}const I={RequestOverviewStart:Symbol("RequestOverviewStart"),RequestNodeHighlight:Symbol("RequestNodeHighlight"),PopulateNodes:Symbol("PopulateNodes"),RequestOverviewCancel:Symbol("RequestOverviewCancel"),OverviewCompleted:Symbol("OverviewCompleted"),Reset:Symbol("Reset")};var k=Object.freeze({__proto__:null,OverviewController:$,Events:I});class E{static _add(e,t,s){const i=e.get(t)||[];i.push(s),e.set(t,i)}static checkForUnusedPositionValues(e,t,s,i,n,o,a,r){if("static"===s[i]){if("auto"!==s[n]){const i=ls`Top applied to a statically positioned element`;this._add(e,i,{declaration:"top: "+s[n],nodeId:t})}if("auto"!==s[o]){const i=ls`Left applied to a statically positioned element`;this._add(e,i,{declaration:"left: "+s[o],nodeId:t})}if("auto"!==s[a]){const i=ls`Right applied to a statically positioned element`;this._add(e,i,{declaration:"right: "+s[a],nodeId:t})}if("auto"!==s[r]){const i=ls`Bottom applied to a statically positioned element`;this._add(e,i,{declaration:"bottom: "+s[r],nodeId:t})}}}static checkForUnusedWidthAndHeightValues(e,t,s,i,n,o){if("inline"===s[i]){if("auto"!==s[n]){const i=ls`Width applied to an inline element`;this._add(e,i,{declaration:"width: "+s[n],nodeId:t})}if("auto"!==s[o]){const i=ls`Height applied to an inline element`;this._add(e,i,{declaration:"height: "+s[o],nodeId:t})}}}static checkForInvalidVerticalAlignment(e,t,s,i,n){if(s[i]&&"inline"!==s[i]&&!s[i].startsWith("table")&&"baseline"!==s[n]){const i=ls`Vertical alignment applied to element which is neither inline nor table-cell`;this._add(e,i,{declaration:"vertical-align: "+s[n],nodeId:t})}}}var x=Object.freeze({__proto__:null,UnusedDeclaration:undefined,CSSOverviewUnusedDeclarations:E});class T extends n.SDKModel{constructor(e){super(e),this._runtimeAgent=e.runtimeAgent(),this._cssAgent=e.cssAgent(),this._domAgent=e.domAgent(),this._domSnapshotAgent=e.domsnapshotAgent(),this._overlayAgent=e.overlayAgent()}highlightNode(e){const s={contentColor:t.PageHighlight.Content.toProtocolRGBA(),showInfo:!0,contrastAlgorithm:l.experiments.isEnabled("APCA")?Protocol.Overlay.ContrastAlgorithm.Apca:Protocol.Overlay.ContrastAlgorithm.Aa};this._overlayAgent.invoke_hideHighlight(),this._overlayAgent.invoke_highlightNode({backendNodeId:e,highlightConfig:s})}async getNodeStyleStats(){const e=new Map,s=new Map,i=new Map,n=new Map,o=new Map,a=new Map,d=new Map,c=e=>e.hasAlpha()?e.asString(t.Format.HEXA):e.asString(t.Format.HEX),h=(e,s,i)=>{if(-1===e)return;const n=g[e];if(!n)return;const o=t.Color.parse(n);if(!o||0===o.rgba()[3])return;const a=c(o);if(!a)return;const r=i.get(a)||new Set;return r.add(s),i.set(a,r),o},u=e=>new Set(["altglyph","circle","ellipse","path","polygon","polyline","rect","svg","text","textpath","tref","tspan"]).has(e.toLowerCase()),m=e=>new Set(["iframe","video","embed","img"]).has(e.toLowerCase()),v=(e,t)=>new Set(["tr","td","thead","tbody"]).has(e.toLowerCase())&&t.startsWith("table");let p=0;const{documents:_,strings:g}=await this._domSnapshotAgent.invoke_captureSnapshot({computedStyles:["background-color","color","fill","border-top-width","border-top-color","border-bottom-width","border-bottom-color","border-left-width","border-left-color","border-right-width","border-right-color","font-family","font-size","font-weight","line-height","position","top","right","bottom","left","display","width","height","vertical-align"]});for(const{nodes:b,layout:f}of _){p+=f.nodeIndex.length;for(let p=0;p<f.styles.length;p++){const _=f.styles[p],C=f.nodeIndex[p];if(!b.backendNodeId||!b.nodeName)continue;const w=b.backendNodeId[C],S=b.nodeName[C],[y,$,I,k,x,T,M,A,L,O,F,R,V,N,P,D,W,q,B,z,G,U,H,j]=_,Q=h(y,w,e),X=h($,w,s);if(u(g[S])&&h(I,w,n),"0px"!==g[k]&&h(x,w,o),"0px"!==g[T]&&h(M,w,o),"0px"!==g[A]&&h(L,w,o),"0px"!==g[O]&&h(F,w,o),R&&-1!==R){const e=g[R],t=a.get(e)||new Map,s="font-size",i="font-weight",n="line-height",o=t.get(s)||new Map,r=t.get(i)||new Map,l=t.get(n)||new Map;if(-1!==V){const e=g[V],t=o.get(e)||[];t.push(w),o.set(e,t)}if(-1!==N){const e=g[N],t=r.get(e)||[];t.push(w),r.set(e,t)}if(-1!==P){const e=g[P],t=l.get(e)||[];t.push(w),l.set(e,t)}t.set(s,o),t.set(i,r),t.set(n,l),a.set(e,t)}if(Q&&X&&"#text"===g[S]){const e=new r.ContrastInfo({backgroundColors:[Q.asString(t.Format.HEXA)],computedFontSize:-1!==V?g[V]:"",computedFontWeight:-1!==N?g[N]:""});e.setColor(X);const s=`${c(X)}_${c(Q)}`;if(l.experiments.isEnabled("APCA")){const t=e.contrastRatioAPCA(),n=e.contrastRatioAPCAThreshold();if(!(!(!t||!n)&&Math.abs(t)>=n)){const e={nodeId:w,contrastRatio:t,textColor:X,backgroundColor:Q,thresholdsViolated:{aa:!1,aaa:!1,apca:!0}};i.has(s)?i.get(s).push(e):i.set(s,[e])}}else{const t=e.contrastRatioThreshold("aa")||0,n=e.contrastRatioThreshold("aaa")||0,o=e.contrastRatio()||0;if(t>o||n>o){const e={nodeId:w,contrastRatio:o,textColor:X,backgroundColor:Q,thresholdsViolated:{aa:t>o,aaa:n>o,apca:!1}};i.has(s)?i.get(s).push(e):i.set(s,[e])}}}E.checkForUnusedPositionValues(d,w,g,D,W,z,q,B),u(g[S])||m(g[S])||E.checkForUnusedWidthAndHeightValues(d,w,g,G,U,H),-1===j||v(g[S],g[G])||E.checkForInvalidVerticalAlignment(d,w,g,G,j)}}return{backgroundColors:e,textColors:s,textColorContrastIssues:i,fillColors:n,borderColors:o,fontInfo:a,unusedDeclarations:d,elementCount:p}}getComputedStyleForNode(e){return this._cssAgent.invoke_getComputedStyleForNode({nodeId:e})}async getMediaQueries(){const e=await this._cssAgent.invoke_getMediaQueries(),t=new Map;if(!e)return t;for(const s of e.medias){if("linkedSheet"===s.source)continue;const e=t.get(s.text)||[];e.push(s),t.set(s.text,e)}return t}async getGlobalStylesheetStats(){const{result:e}=await this._runtimeAgent.invoke_evaluate({expression:"(function() {\n      let styleRules = 0;\n      let inlineStyles = 0;\n      let externalSheets = 0;\n      const stats = {\n        // Simple.\n        type: new Set(),\n        class: new Set(),\n        id: new Set(),\n        universal: new Set(),\n        attribute: new Set(),\n\n        // Non-simple.\n        nonSimple: new Set()\n      };\n\n      for (const styleSheet of document.styleSheets) {\n        if (styleSheet.href) {\n          externalSheets++;\n        } else {\n          inlineStyles++;\n        }\n\n        // Attempting to grab rules can trigger a DOMException.\n        // Try it and if it fails skip to the next stylesheet.\n        let rules;\n        try {\n          rules = styleSheet.rules;\n        } catch (err) {\n          continue;\n        }\n\n        for (const rule of rules) {\n          if ('selectorText' in rule) {\n            styleRules++;\n\n            // Each group that was used.\n            for (const selectorGroup of rule.selectorText.split(',')) {\n              // Each selector in the group.\n              for (const selector of selectorGroup.split(/[\\t\\n\\f\\r ]+/g)) {\n                if (selector.startsWith('.')) {\n                  // Class.\n                  stats.class.add(selector);\n                } else if (selector.startsWith('#')) {\n                  // Id.\n                  stats.id.add(selector);\n                } else if (selector.startsWith('*')) {\n                  // Universal.\n                  stats.universal.add(selector);\n                } else if (selector.startsWith('[')) {\n                  // Attribute.\n                  stats.attribute.add(selector);\n                } else {\n                  // Type or non-simple selector.\n                  const specialChars = /[#.:\\[\\]|\\+>~]/;\n                  if (specialChars.test(selector)) {\n                    stats.nonSimple.add(selector);\n                  } else {\n                    stats.type.add(selector);\n                  }\n                }\n              }\n            }\n          }\n        }\n      }\n\n      return {\n        styleRules,\n        inlineStyles,\n        externalSheets,\n        stats: {\n          // Simple.\n          type: stats.type.size,\n          class: stats.class.size,\n          id: stats.id.size,\n          universal: stats.universal.size,\n          attribute: stats.attribute.size,\n\n          // Non-simple.\n          nonSimple: stats.nonSimple.size\n        }\n      }\n    })()",returnByValue:!0});if("object"===e.type)return e.value}}n.SDKModel.register(T,n.Capability.DOM,!1);var M=Object.freeze({__proto__:null,CSSOverviewModel:T});class A extends d.Widget{constructor(e){super(),this.registerRequiredCSS("css_overview/cssOverviewStartView.css",{enableLegacyPatching:!1}),this._controller=e,this._render()}_render(){const e=c.createTextButton(ls`Capture overview`,(()=>this._controller.dispatchEventToListeners(I.RequestOverviewStart)),"",!0);this.setDefaultFocusedElement(e);const t=h.Fragment.build`
      <div class="vbox overview-start-view">
        <h1>${ls`CSS Overview`}</h1>
        <div>${e}</div>
      </div>
    `;this.contentElement.appendChild(t.element()),this.contentElement.style.overflow="auto"}}var L=Object.freeze({__proto__:null,CSSOverviewStartView:A});class O extends d.Widget{constructor(e){super(),this.registerRequiredCSS("css_overview/cssOverviewProcessingView.css",{enableLegacyPatching:!1}),this._formatter=new Intl.NumberFormat("en-US"),this._controller=e,this._render()}_render(){const e=c.createTextButton(ls`Cancel`,(()=>this._controller.dispatchEventToListeners(I.RequestOverviewCancel)),"",!0);this.setDefaultFocusedElement(e),this.fragment=h.Fragment.build`
      <div class="vbox overview-processing-view">
        <h1>Processing page</h1>
        <div>${e}</div>
      </div>
    `,this.contentElement.appendChild(this.fragment.element()),this.contentElement.style.overflow="auto"}}var F=Object.freeze({__proto__:null,CSSOverviewProcessingView:O});class R extends d.VBox{static get ITEM_CLASS_NAME(){return"overview-sidebar-panel-item"}static get SELECTED(){return"selected"}constructor(){super(!0),this.registerRequiredCSS("css_overview/cssOverviewSidebarPanel.css",{enableLegacyPatching:!1}),this.contentElement.classList.add("overview-sidebar-panel"),this.contentElement.addEventListener("click",this._onItemClick.bind(this));const e=new u.ToolbarButton(ls`Clear overview`,"largeicon-clear");e.addEventListener(u.ToolbarButton.Events.Click,this._reset,this);const t=this.contentElement.createChild("div","overview-toolbar");new u.Toolbar("",t).appendToolbarItem(e)}addItem(e,t){const s=this.contentElement.createChild("div",R.ITEM_CLASS_NAME);s.textContent=e,s.dataset.id=t}_reset(){this.dispatchEventToListeners(V.Reset)}_deselectAllItems(){this.contentElement.querySelectorAll("."+R.ITEM_CLASS_NAME).forEach((e=>{e.classList.remove(R.SELECTED)}))}_onItemClick(e){const t=e.composedPath()[0];if(!t.classList.contains(R.ITEM_CLASS_NAME))return;const{id:s}=t.dataset;s&&(this.select(s),this.dispatchEventToListeners(V.ItemSelected,s))}select(e){const t=this.contentElement.querySelector(`[data-id=${CSS.escape(e)}]`);t&&(t.classList.contains(R.SELECTED)||(this._deselectAllItems(),t.classList.add(R.SELECTED)))}}const V={ItemSelected:Symbol("ItemSelected"),Reset:Symbol("Reset")};var N=Object.freeze({__proto__:null,CSSOverviewSidebarPanel:R,SidebarEvents:V});function P(e){let[t,s,i]=e.hsla();return t=Math.round(360*t),s=Math.round(100*s),i=Math.round(100*i),i=Math.max(0,i-15),`1px solid hsl(${t}deg ${s}% ${i}%)`}class D extends m.PanelWithSidebar{constructor(e,t){super("css_overview_completed_view"),this.registerRequiredCSS("css_overview/cssOverviewCompletedView.css",{enableLegacyPatching:!1}),this._controller=e,this._formatter=new Intl.NumberFormat("en-US"),this._mainContainer=new v.SplitWidget(!0,!0),this._resultsContainer=new d.VBox,this._elementContainer=new W,this._elementContainer.addEventListener(p.Events.TabClosed,(e=>{0===e.data&&this._mainContainer.setSidebarMinimized(!0)})),this._mainContainer.registerRequiredCSS("css_overview/cssOverviewCompletedView.css",{enableLegacyPatching:!0}),this._mainContainer.setMainWidget(this._resultsContainer),this._mainContainer.setSidebarWidget(this._elementContainer),this._mainContainer.setVertical(!1),this._mainContainer.setSecondIsSidebar(!0),this._mainContainer.setSidebarMinimized(!0),this._sideBar=new R,this.splitWidget().setSidebarWidget(this._sideBar),this.splitWidget().setMainWidget(this._mainContainer);const s=t.model(o.CSSModel),i=t.model(a.DOMModel);if(!s||!i)throw new Error("Target must provide CSS and DOM models");this._cssModel=s,this._domModel=i,this._domAgent=t.domAgent(),this._linkifier=new b.Linkifier(20,!0),this._viewMap=new Map,this._sideBar.addItem(ls`Overview summary`,"summary"),this._sideBar.addItem(ls`Colors`,"colors"),this._sideBar.addItem(ls`Font info`,"font-info"),this._sideBar.addItem(ls`Unused declarations`,"unused-declarations"),this._sideBar.addItem(ls`Media queries`,"media-queries"),this._sideBar.select("summary"),this._sideBar.addEventListener(V.ItemSelected,this._sideBarItemSelected,this),this._sideBar.addEventListener(V.Reset,this._sideBarReset,this),this._controller.addEventListener(I.Reset,this._reset,this),this._controller.addEventListener(I.PopulateNodes,this._createElementsView,this),this._resultsContainer.element.addEventListener("click",this._onClick.bind(this)),this._data=null}wasShown(){super.wasShown()}_sideBarItemSelected(e){const t=e.data,s=this._fragment.$(t);s&&s.scrollIntoView()}_sideBarReset(){this._controller.dispatchEventToListeners(I.Reset)}_reset(){this._resultsContainer.element.removeChildren(),this._mainContainer.setSidebarMinimized(!0),this._elementContainer.closeTabs(),this._viewMap=new Map,D.pushedNodes.clear(),this._sideBar.select("summary")}_onClick(e){if(!e.target)return;const t=e.target.dataset,s=t.type;if(!s||!this._data)return;let i;switch(s){case"contrast":{const e=t.section,n=t.key;if(!n)return;i={type:s,key:n,nodes:this._data.textColorContrastIssues.get(n)||[],section:e};break}case"color":{const e=t.color,n=t.section;if(!e)return;let o;switch(n){case"text":o=this._data.textColors.get(e);break;case"background":o=this._data.backgroundColors.get(e);break;case"fill":o=this._data.fillColors.get(e);break;case"border":o=this._data.borderColors.get(e)}if(!o)return;o=Array.from(o).map((e=>({nodeId:e}))),i={type:s,color:e,nodes:o,section:n};break}case"unused-declarations":{const e=t.declaration;if(!e)return;const n=this._data.unusedDeclarations.get(e);if(!n)return;i={type:s,declaration:e,nodes:n};break}case"media-queries":{const e=t.text;if(!e)return;const n=this._data.mediaQueries.get(e);if(!n)return;i={type:s,text:e,nodes:n};break}case"font-info":{const e=t.value;if(!t.path)return;const[n,o]=t.path.split("/");if(!e)return;const a=this._data.fontInfo.get(n);if(!a)return;const r=a.get(o);if(!r)return;const l=r.get(e);if(!l)return;i={type:s,name:`${e} (${n}, ${o})`,nodes:l.map((e=>({nodeId:e})))};break}default:return}e.consume(),this._controller.dispatchEventToListeners(I.PopulateNodes,i),this._mainContainer.setSidebarMinimized(!1)}_onMouseOver(e){const t=e.composedPath().find((e=>e.dataset&&e.dataset.backendNodeId));if(!t)return;const s=Number(t.dataset.backendNodeId);this._controller.dispatchEventToListeners(I.RequestNodeHighlight,s)}async _render(e){if(!e||!("backgroundColors"in e)||!("textColors"in e))return;this._data=e;const{elementCount:t,backgroundColors:s,textColors:i,textColorContrastIssues:n,fillColors:o,borderColors:a,globalStyleStats:r,mediaQueries:l,unusedDeclarations:d,fontInfo:c}=this._data,u=this._sortColorsByLuminance(s),m=this._sortColorsByLuminance(i),v=this._sortColorsByLuminance(o),p=this._sortColorsByLuminance(a);this._fragment=h.Fragment.build`
    <div class="vbox overview-completed-view">
      <div $="summary" class="results-section horizontally-padded summary">
        <h1>${ls`Overview summary`}</h1>

        <ul>
          <li>
            <div class="label">${ls`Elements`}</div>
            <div class="value">${this._formatter.format(t)}</div>
          </li>
          <li>
            <div class="label">${ls`External stylesheets`}</div>
            <div class="value">${this._formatter.format(r.externalSheets)}</div>
          </li>
          <li>
            <div class="label">${ls`Inline style elements`}</div>
            <div class="value">${this._formatter.format(r.inlineStyles)}</div>
          </li>
          <li>
            <div class="label">${ls`Style rules`}</div>
            <div class="value">${this._formatter.format(r.styleRules)}</div>
          </li>
          <li>
            <div class="label">${ls`Media queries`}</div>
            <div class="value">${this._formatter.format(l.size)}</div>
          </li>
          <li>
            <div class="label">${ls`Type selectors`}</div>
            <div class="value">${this._formatter.format(r.stats.type)}</div>
          </li>
          <li>
            <div class="label">${ls`ID selectors`}</div>
            <div class="value">${this._formatter.format(r.stats.id)}</div>
          </li>
          <li>
            <div class="label">${ls`Class selectors`}</div>
            <div class="value">${this._formatter.format(r.stats.class)}</div>
          </li>
          <li>
            <div class="label">${ls`Universal selectors`}</div>
            <div class="value">${this._formatter.format(r.stats.universal)}</div>
          </li>
          <li>
            <div class="label">${ls`Attribute selectors`}</div>
            <div class="value">${this._formatter.format(r.stats.attribute)}</div>
          </li>
          <li>
            <div class="label">${ls`Non-simple selectors`}</div>
            <div class="value">${this._formatter.format(r.stats.nonSimple)}</div>
          </li>
        </ul>
      </div>

      <div $="colors" class="results-section horizontally-padded colors">
        <h1>${ls`Colors`}</h1>
        <h2>${ls`Background colors: ${u.length}`}</h2>
        <ul>
          ${u.map(this._colorsToFragment.bind(this,"background"))}
        </ul>

        <h2>${ls`Text colors: ${m.length}`}</h2>
        <ul>
          ${m.map(this._colorsToFragment.bind(this,"text"))}
        </ul>

        ${n.size>0?this._contrastIssuesToFragment(n):""}

        <h2>${ls`Fill colors: ${v.length}`}</h2>
        <ul>
          ${v.map(this._colorsToFragment.bind(this,"fill"))}
        </ul>

        <h2>${ls`Border colors: ${p.length}`}</h2>
        <ul>
          ${p.map(this._colorsToFragment.bind(this,"border"))}
        </ul>
      </div>

      <div $="font-info" class="results-section font-info">
        <h1>${ls`Font info`}</h1>
        ${c.size>0?this._fontInfoToFragment(c):h.Fragment.build`<div>${ls`There are no fonts.`}</div>`}
      </div>

      <div $="unused-declarations" class="results-section unused-declarations">
        <h1>${ls`Unused declarations`}</h1>
        ${d.size>0?this._groupToFragment(d,"unused-declarations","declaration"):h.Fragment.build`<div class="horizontally-padded">${ls`There are no unused declarations.`}</div>`}
      </div>

      <div $="media-queries" class="results-section media-queries">
        <h1>${ls`Media queries`}</h1>
        ${l.size>0?this._groupToFragment(l,"media-queries","text"):h.Fragment.build`<div class="horizontally-padded">${ls`There are no media queries.`}</div>`}
      </div>
    </div>`,this._resultsContainer.element.appendChild(this._fragment.element())}_createElementsView(e){const{type:t,nodes:s}=e.data;let i="",n="";switch(t){case"contrast":{const{section:t,key:s}=e.data;i=`${t}-${s}`,n=ls`Contrast issues`;break}case"color":{const{section:t,color:s}=e.data;i=`${t}-${s}`,n=`${s.toUpperCase()} (${t})`;break}case"unused-declarations":{const{declaration:t}=e.data;i=""+t,n=""+t;break}case"media-queries":{const{text:t}=e.data;i=""+t,n=""+t;break}case"font-info":{const{name:t}=e.data;i=""+t,n=""+t;break}}let o=this._viewMap.get(i);o||(o=new q(this._controller,this._domModel,this._cssModel,this._linkifier),o.populateNodes(s),this._viewMap.set(i,o)),this._elementContainer.appendTab(i,n,o,!0)}_fontInfoToFragment(e){const t=Array.from(e.entries());return h.Fragment.build`
      ${t.map((([e,t])=>h.Fragment.build`<section class="font-family"><h2>${e}</h2> ${this._fontMetricsToFragment(e,t)}</section>`))}
    `}_fontMetricsToFragment(e,t){const s=Array.from(t.entries());return h.Fragment.build`
      <div class="font-metric">
      ${s.map((([t,s])=>{const i=`${e}/${t}`;return h.Fragment.build`
          <div>
            <h3>${t}</h3>
            ${this._groupToFragment(s,"font-info","value",i)}
          </div>`}))}
      </div>`}_groupToFragment(e,t,s,i=""){const n=Array.from(e.entries()).sort(((e,t)=>{const s=e[1];return t[1].length-s.length})),o=n.reduce(((e,t)=>e+t[1].length),0);return h.Fragment.build`<ul>
    ${n.map((([e,n])=>{const a=100*n.length/o,r=1===n.length?ls`occurrence`:ls`occurrences`;return h.Fragment.build`<li>
        <div class="title">${e}</div>
        <button data-type="${t}" data-path="${i}" data-${s}="${e}">
          <div class="details">${ls`${n.length} ${r}`}</div>
          <div class="bar-container">
            <div class="bar" style="width: ${a}%"></div>
          </div>
        </button>
      </li>`}))}
    </ul>`}_contrastIssuesToFragment(e){return h.Fragment.build`
      <h2>${ls`Contrast issues: ${e.size}`}</h2>
      <ul>
        ${[...e.entries()].map((([e,t])=>this._contrastIssueToFragment(e,t)))}
      </ul>
    `}_contrastIssueToFragment(e,s){console.assert(s.length>0);let i=s[0];for(const e of s)Math.abs(e.contrastRatio)<Math.abs(i.contrastRatio)&&(i=e);const n=i.textColor.asString(t.Format.HEXA),o=i.backgroundColor.asString(t.Format.HEXA),a=l.experiments.isEnabled("APCA"),r=h.Fragment.build`<li>
      <button
        title="${ls`Text color ${n} over ${o} background results in low contrast for ${s.length} elements`}"
        data-type="contrast" data-key="${e}" data-section="contrast" class="block" $="color">
        Text
      </button>
      <div class="block-title">
        <div class="contrast-warning hidden" $="aa"><span class="threshold-label">${ls`AA`}</span></div>
        <div class="contrast-warning hidden" $="aaa"><span class="threshold-label">${ls`AAA`}</span></div>
        <div class="contrast-warning hidden" $="apca"><span class="threshold-label">${ls`APCA`}</span></div>
      </div>
    </li>`;if(a){const e=r.$("apca");i.thresholdsViolated.apca?e.appendChild(_.Icon.create("smallicon-no")):e.appendChild(_.Icon.create("smallicon-checkmark-square")),e.classList.remove("hidden")}else{const e=r.$("aa");i.thresholdsViolated.aa?e.appendChild(_.Icon.create("smallicon-no")):e.appendChild(_.Icon.create("smallicon-checkmark-square"));const t=r.$("aaa");i.thresholdsViolated.aaa?t.appendChild(_.Icon.create("smallicon-no")):t.appendChild(_.Icon.create("smallicon-checkmark-square")),e.classList.remove("hidden"),t.classList.remove("hidden")}const d=r.$("color");return d.style.backgroundColor=o,d.style.color=n,d.style.border=P(i.backgroundColor),r}_colorsToFragment(e,s){const i=h.Fragment.build`<li>
      <button data-type="color" data-color="${s}" data-section="${e}" class="block" $="color"></button>
      <div class="block-title">${s}</div>
    </li>`,n=i.$("color");n.style.backgroundColor=s;const o=t.Color.parse(s);if(o)return n.style.border=P(o),i}_sortColorsByLuminance(e){return Array.from(e.keys()).sort(((e,i)=>{const n=t.Color.parse(e),o=t.Color.parse(i);return n&&o?s.luminance(o.rgba())-s.luminance(n.rgba()):0}))}setOverviewData(e){this._render(e)}}D.pushedNodes=new Set;class W extends d.VBox{constructor(){super(),this._tabbedPane=new p.TabbedPane,this._tabbedPane.show(this.element),this._tabbedPane.addEventListener(p.Events.TabClosed,(()=>{this.dispatchEventToListeners(p.Events.TabClosed,this._tabbedPane.tabIds().length)}))}appendTab(e,t,s,i){this._tabbedPane.hasTab(e)||this._tabbedPane.appendTab(e,t,s,void 0,void 0,i),this._tabbedPane.selectTab(e)}closeTabs(){this._tabbedPane.closeTabs(this._tabbedPane.tabIds())}}class q extends d.Widget{constructor(e,t,s,i){super(),this._controller=e,this._domModel=t,this._cssModel=s,this._linkifier=i,this._elementGridColumns=[{id:"nodeId",title:ls`Element`,sortable:!0,weight:50,titleDOMFragment:void 0,sort:void 0,align:void 0,width:void 0,fixedWidth:void 0,editable:void 0,nonSelectable:void 0,longText:void 0,disclosure:void 0,allowInSortByEvenWhenHidden:void 0,dataType:void 0,defaultWeight:void 0},{id:"declaration",title:ls`Declaration`,sortable:!0,weight:50,titleDOMFragment:void 0,sort:void 0,align:void 0,width:void 0,fixedWidth:void 0,editable:void 0,nonSelectable:void 0,longText:void 0,disclosure:void 0,allowInSortByEvenWhenHidden:void 0,dataType:void 0,defaultWeight:void 0},{id:"sourceURL",title:ls`Source`,sortable:!1,weight:100,titleDOMFragment:void 0,sort:void 0,align:void 0,width:void 0,fixedWidth:void 0,editable:void 0,nonSelectable:void 0,longText:void 0,disclosure:void 0,allowInSortByEvenWhenHidden:void 0,dataType:void 0,defaultWeight:void 0},{id:"contrastRatio",title:ls`Contrast ratio`,sortable:!0,weight:25,titleDOMFragment:void 0,sort:void 0,align:void 0,width:"150px",fixedWidth:!0,editable:void 0,nonSelectable:void 0,longText:void 0,disclosure:void 0,allowInSortByEvenWhenHidden:void 0,dataType:void 0,defaultWeight:void 0}],this._elementGrid=new f.SortableDataGrid({displayName:ls`CSS Overview Elements`,columns:this._elementGridColumns,editCallback:void 0,deleteCallback:void 0,refreshCallback:void 0}),this._elementGrid.element.classList.add("element-grid"),this._elementGrid.element.addEventListener("mouseover",this._onMouseOver.bind(this)),this._elementGrid.setStriped(!0),this._elementGrid.addEventListener(C.Events.SortingChanged,this._sortMediaQueryDataGrid.bind(this)),this.element.appendChild(this._elementGrid.element)}_sortMediaQueryDataGrid(){const e=this._elementGrid.sortColumnId();if(!e)return;const t=f.SortableDataGrid.StringComparator.bind(null,e);this._elementGrid.sortNodes(t,!this._elementGrid.isSortOrderAscending())}_onMouseOver(e){const t=e.composedPath().find((e=>e.dataset&&e.dataset.backendNodeId));if(!t)return;const s=Number(t.dataset.backendNodeId);this._controller.dispatchEventToListeners(I.RequestNodeHighlight,s)}async populateNodes(e){if(this._elementGrid.rootNode().removeChildren(),!e.length)return;const[t]=e,s=new Set;let i;if(t.nodeId&&s.add("nodeId"),t.declaration&&s.add("declaration"),t.sourceURL&&s.add("sourceURL"),t.contrastRatio&&s.add("contrastRatio"),s.has("nodeId")){const t=e.reduce(((e,t)=>D.pushedNodes.has(t.nodeId)?e:(D.pushedNodes.add(t.nodeId),e.add(t.nodeId))),new Set);i=await this._domModel.pushNodesByBackendIdsToFrontend(t)}for(const t of e){if(s.has("nodeId")){if(!i)continue;const e=i.get(t.nodeId);if(!e)continue;t.node=e}const e=new B(this._elementGrid,t,this._linkifier,this._cssModel);e.selectable=!1,this._elementGrid.insertChild(e)}this._elementGrid.setColumnsVisiblity(s),this._elementGrid.renderInline(),this._elementGrid.wasShown()}}class B extends f.SortableDataGridNode{constructor(e,t,s,i){super(e,t.hasChildren),this.data=t,this._linkifier=s,this._cssModel=i}createCell(e){if("nodeId"===e){const t=this.createTD(e);return t.textContent="...",i.Linkifier.linkify(this.data.node).then((e=>{t.textContent="",e.dataset.backendNodeId=this.data.node.backendNodeId(),t.appendChild(e);const s=document.createElement("button");s.classList.add("show-element"),g.Tooltip.install(s,ls`Show element`),s.tabIndex=0,s.onclick=()=>this.data.node.scrollIntoView(),t.appendChild(s)})),t}if("sourceURL"===e){const t=this.createTD(e);if(this.data.range){const e=this._linkifyRuleLocation(this._cssModel,this._linkifier,this.data.styleSheetId,w.TextRange.fromObject(this.data.range));e&&""!==e.textContent?t.appendChild(e):t.textContent="(unable to link)"}else t.textContent="(unable to link to inlined styles)";return t}if("contrastRatio"===e){const t=this.createTD(e),s=l.experiments.isEnabled("APCA"),i=s?this.data.contrastRatio.toFixed(2)+"%":this.data.contrastRatio.toFixed(2),n=h.Fragment.build`
        <div class="contrast-container-in-grid" $="container">
          <span class="contrast-preview" style="border: ${P(this.data.backgroundColor)}; color: ${this.data.textColor.asString()}; background-color: ${this.data.backgroundColor.asString()};">Aa</span>
          <span>${i}</span>
        </div>
      `,o=n.$("container");return s?(o.append(h.Fragment.build`<span>${ls`APCA`}</span>`.element()),this.data.thresholdsViolated.apca?o.appendChild(_.Icon.create("smallicon-no")):o.appendChild(_.Icon.create("smallicon-checkmark-square"))):(o.append(h.Fragment.build`<span>${ls`AA`}</span>`.element()),this.data.thresholdsViolated.aa?o.appendChild(_.Icon.create("smallicon-no")):o.appendChild(_.Icon.create("smallicon-checkmark-square")),o.append(h.Fragment.build`<span>${ls`AAA`}</span>`.element()),this.data.thresholdsViolated.aaa?o.appendChild(_.Icon.create("smallicon-no")):o.appendChild(_.Icon.create("smallicon-checkmark-square"))),t.appendChild(n.element()),t}return super.createCell(e)}_linkifyRuleLocation(e,t,s,i){const n=e.styleSheetHeaderForId(s);if(!n)return;const a=n.lineNumberInSource(i.startLine),r=n.columnNumberInSource(i.startLine,i.startColumn),l=new o.CSSLocation(n,a,r);return t.linkifyCSSLocation(l)}}var z=Object.freeze({__proto__:null,NodeStyleStats:undefined,ContrastIssue:undefined,OverviewData:undefined,FontInfo:undefined,CSSOverviewCompletedView:D,DetailsView:W,ElementDetailsView:q,ElementNode:B});let G;class U extends m.Panel{constructor(){super("css_overview"),this.registerRequiredCSS("css_overview/cssOverview.css",{enableLegacyPatching:!1}),this.element.classList.add("css-overview-panel");const[e]=n.TargetManager.instance().models(T);this._model=e,this._controller=new $,this._startView=new A(this._controller),this._processingView=new O(this._controller),this._completedView=new D(this._controller,e.target()),this._controller.addEventListener(I.RequestOverviewStart,(e=>{S.actionTaken(y.Action.CaptureCssOverviewClicked),this._startOverview()}),this),this._controller.addEventListener(I.RequestOverviewCancel,this._cancelOverview,this),this._controller.addEventListener(I.OverviewCompleted,this._overviewCompleted,this),this._controller.addEventListener(I.Reset,this._reset,this),this._controller.addEventListener(I.RequestNodeHighlight,this._requestNodeHighlight,this),this._reset()}static instance(){return G||(G=new U),G}_reset(){this._backgroundColors=new Map,this._textColors=new Map,this._fillColors=new Map,this._borderColors=new Map,this._fontInfo=new Map,this._mediaQueries=new Map,this._unusedDeclarations=new Map,this._elementCount=0,this._cancelled=!1,this._globalStyleStats={styleRules:0,inlineStyles:0,externalSheets:0,stats:{type:0,class:0,id:0,universal:0,attribute:0,nonSimple:0}},this._renderInitialView()}_requestNodeHighlight(e){this._model.highlightNode(e.data)}_renderInitialView(){this._processingView.hideWidget(),this._completedView.hideWidget(),this._startView.show(this.contentElement)}_renderOverviewStartedView(){this._startView.hideWidget(),this._completedView.hideWidget(),this._processingView.show(this.contentElement)}_renderOverviewCompletedView(){this._startView.hideWidget(),this._processingView.hideWidget(),this._completedView.show(this.contentElement),this._completedView.setOverviewData({backgroundColors:this._backgroundColors,textColors:this._textColors,textColorContrastIssues:this._textColorContrastIssues,fillColors:this._fillColors,borderColors:this._borderColors,globalStyleStats:this._globalStyleStats,fontInfo:this._fontInfo,elementCount:this._elementCount,mediaQueries:this._mediaQueries,unusedDeclarations:this._unusedDeclarations})}async _startOverview(){this._renderOverviewStartedView();const[e,{elementCount:t,backgroundColors:s,textColors:i,textColorContrastIssues:n,fillColors:o,borderColors:a,fontInfo:r,unusedDeclarations:l},d]=await Promise.all([this._model.getGlobalStylesheetStats(),this._model.getNodeStyleStats(),this._model.getMediaQueries()]);t&&(this._elementCount=t),e&&(this._globalStyleStats=e),d&&(this._mediaQueries=d),s&&(this._backgroundColors=s),i&&(this._textColors=i),n&&(this._textColorContrastIssues=n),o&&(this._fillColors=o),a&&(this._borderColors=a),r&&(this._fontInfo=r),l&&(this._unusedDeclarations=l),this._controller.dispatchEventToListeners(I.OverviewCompleted)}_getStyleValue(e,t){const s=e.filter((e=>e.name===t));if(s.length)return s[0].value}_cancelOverview(){this._cancelled=!0}_overviewCompleted(){this._renderOverviewCompletedView()}}var H=Object.freeze({__proto__:null,CSSOverviewPanel:U});export{z as CSSOverviewCompletedView,k as CSSOverviewController,M as CSSOverviewModel,H as CSSOverviewPanel,F as CSSOverviewProcessingView,N as CSSOverviewSidebarPanel,L as CSSOverviewStartView,x as CSSOverviewUnusedDeclarations};
