import{ls as e}from"../../common/common.js";import{Platform as t}from"../../host/host.js";import{assertNever as o,NumberUtilities as i}from"../../platform/platform.js";import{html as s,nothing as r,Directives as n,render as l}from"../../third_party/lit-html/lit-html.js";import{ContextMenu as a}from"../ui.js";import{ResourceUtils as c}from"../../bindings/bindings.js";const h=e=>s`${e}`;var d=Object.freeze({__proto__:null,primitiveRenderer:h,codeBlockRenderer:e=>s`<code>${e}</code>`});const u=new Set(["ArrowUp","ArrowDown","ArrowLeft","ArrowRight"]);function m(e){return u.has(e)}function f(e,t){const o=e.cells.find((e=>e.columnId===t));if(void 0===o)throw new Error(`Found a row that was missing an entry for column ${t}.`);return o}function p(e){return e.renderer?e.renderer(e.value):h(e.value)}function w(e,t){const o=e.filter((e=>e.visible)).reduce(((e,t)=>e+t.widthWeighting),0),i=e.find((e=>e.id===t));if(!i)throw new Error("Could not find column with ID "+t);if(i.widthWeighting<1)throw new Error(`Error with column ${t}: width weightings must be >= 1.`);return i.visible?Math.round(i.widthWeighting/o*100):0}function b(e){const{key:t,currentFocusedCell:i,columns:s,rows:r}=e,[n,l]=i;switch(t){case"ArrowLeft":{if(n===s.findIndex((e=>e.visible)))return[n,l];let e=n;for(let t=e-1;t>=0;t--){if(s[t].visible){e=t;break}}return[e,l]}case"ArrowRight":{let e=n;for(let t=e+1;t<s.length;t++){if(s[t].visible){e=t;break}}return[e,l]}case"ArrowUp":{const e=s.some((e=>!0===e.sortable))?0:1;if(l===e)return[n,l];let t=l;for(let o=l-1;o>=e;o--){if(0===o){t=0;break}if(!r[o-1].hidden){t=o;break}}return[n,t]}case"ArrowDown":{if(0===l){const e=r.findIndex((e=>!e.hidden));return e>-1?[n,e+1]:[n,l]}let e=l;for(let t=e+1;t<r.length+1;t++){if(!r[t-1].hidden){e=t;break}}return[n,e]}default:return o(t,"Unknown arrow key: "+t)}}const g=e=>{const{columns:t,rows:o}=e,i=t.some((e=>!0===e.sortable))?0:o.findIndex((e=>!e.hidden))+1;return[t.findIndex((e=>e.visible)),i]};var v=Object.freeze({__proto__:null,ARROW_KEYS:u,keyIsArrowKey:m,getRowEntryForColumnId:f,renderCellValue:p,calculateColumnWidthPercentageFromWeighting:w,handleArrowKeyNavigation:b,calculateFirstFocusableCell:g});class C extends Event{constructor(e,t){super("column-header-click"),this.data={column:e,columnIndex:t}}}class x extends Event{constructor(e,t){super("cell-focused"),this.data={cell:e,row:t}}}class y extends Event{constructor(e){super("context-menu-column-sort-click"),this.data={column:e}}}const k=new Set([" ","Enter"]);class R extends HTMLElement{constructor(){super(...arguments),this.shadow=this.attachShadow({mode:"open"}),this.columns=[],this.rows=[],this.sortState=null,this.currentResize=null,this.boundOnResizePointerUp=this.onResizePointerUp.bind(this),this.boundOnResizePointerMove=this.onResizePointerMove.bind(this),this.boundOnResizePointerDown=this.onResizePointerDown.bind(this),this.focusableCell=[0,1],this.hasRenderedAtLeastOnce=!1}get data(){return{columns:this.columns,rows:this.rows,activeSort:this.sortState,contextMenus:this.contextMenus}}set data(e){if(this.columns=e.columns,this.rows=e.rows,this.sortState=e.activeSort,this.contextMenus=e.contextMenus,this.hasRenderedAtLeastOnce||(this.focusableCell=g({columns:this.columns,rows:this.rows})),this.hasRenderedAtLeastOnce){const[e,t]=this.focusableCell,o=e>this.columns.length,i=t>this.rows.length;this.focusableCell=o||i?[o?this.columns.length:e,i?this.rows.length:t]:g({columns:this.columns,rows:this.rows})}this.render()}scrollToBottomIfRequired(){if(!1===this.hasRenderedAtLeastOnce)return;const e=this.getCurrentlyFocusableCell();if(e&&e===this.shadow.activeElement)return;const t=this.shadow.querySelector("tbody tr:not(.hidden):last-child");t&&t.scrollIntoView()}getCurrentlyFocusableCell(){const[e,t]=this.focusableCell;return this.shadow.querySelector(`[data-row-index="${t}"][data-col-index="${e}"]`)}focusCell([e,t]){const[o,i]=this.focusableCell;o===e&&i===t||(this.focusableCell=[e,t]);const s=this.getCurrentlyFocusableCell();if(!s)throw new Error("Unexpected error: could not find cell marked as focusable");s.focus(),this.render()}onTableKeyDown(e){const t=e.key;if(k.has(t)){const e=this.getCurrentlyFocusableCell(),[t,o]=this.focusableCell,i=this.columns[t];e&&0===o&&i&&i.sortable&&this.onColumnHeaderClick(i,t)}if(!m(t))return;const o=b({key:t,currentFocusedCell:this.focusableCell,columns:this.columns,rows:this.rows});this.focusCell(o)}onColumnHeaderClick(e,t){this.dispatchEvent(new C(e,t))}ariaSortForHeader(e){return!e.sortable||this.sortState&&this.sortState.columnId===e.id?this.sortState&&this.sortState.columnId===e.id?"ASC"===this.sortState.direction?"ascending":"descending":void 0:"none"}renderFillerRow(){const e=this.columns.map(((e,t)=>{if(!e.visible)return r;const o=n.classMap({firstVisibleColumn:0===t});return s`<td tabindex="-1" class=${o} data-filler-row-column-index=${t}>
    ${this.renderResizeForCell([t+1,this.rows.length])}</td>`}));return s`<tr tabindex="-1" class="filler-row">${e}</tr>`}cleanUpAfterResizeColumnComplete(){this.currentResize&&(this.currentResize.documentForCursorChange.body.style.cursor=this.currentResize.cursorToRestore,this.currentResize=null)}onResizePointerDown(e){if(1!==e.buttons||t.isMac()&&e.ctrlKey)return;e.preventDefault();const o=e.target;if(!o)return;const i=o.parentElement;if(!i)return;let s=i.dataset.colIndex,r=i.dataset.rowIndex;if(i.hasAttribute("data-filler-row-column-index")&&(s=i.dataset.fillerRowColumnIndex,r=String(this.rows.length)),!s||!r)return;const n=[globalThis.parseInt(s,10),globalThis.parseInt(r,10)],l=[this.columns.findIndex(((e,t)=>t>n[0]&&!0===e.visible)),n[1]],a=`[data-col-index="${l[0]}"][data-row-index="${l[1]}"]`,c=this.shadow.querySelector(a);if(!c)return;const h=this.shadow.querySelector(`col[data-col-column-index="${n[0]}"]`),d=this.shadow.querySelector(`col[data-col-column-index="${l[0]}"]`);if(!h||!d)return;const u=e.target.ownerDocument;u&&(this.currentResize={leftCellCol:h,rightCellCol:d,leftCellColInitialPercentageWidth:globalThis.parseInt(h.style.width,10),rightCellColInitialPercentageWidth:globalThis.parseInt(d.style.width,10),initialLeftCellWidth:i.clientWidth,initialRightCellWidth:c.clientWidth,initialMouseX:e.x,documentForCursorChange:u,cursorToRestore:o.style.cursor},u.body.style.cursor="col-resize",o.setPointerCapture(e.pointerId),o.addEventListener("pointermove",this.boundOnResizePointerMove))}onResizePointerMove(e){if(e.preventDefault(),!this.currentResize)return;const t=this.currentResize.leftCellColInitialPercentageWidth+this.currentResize.rightCellColInitialPercentageWidth-10,o=e.x-this.currentResize.initialMouseX,s=Math.abs(o)/(this.currentResize.initialLeftCellWidth+this.currentResize.initialRightCellWidth)*100;let r,n;o>0?(r=i.clamp(this.currentResize.leftCellColInitialPercentageWidth+s,10,t),n=i.clamp(this.currentResize.rightCellColInitialPercentageWidth-s,10,t)):o<0&&(r=i.clamp(this.currentResize.leftCellColInitialPercentageWidth-s,10,t),n=i.clamp(this.currentResize.rightCellColInitialPercentageWidth+s,10,t)),r&&n&&(this.currentResize.leftCellCol.style.width=Math.floor(r)+"%",this.currentResize.rightCellCol.style.width=Math.ceil(n)+"%")}onResizePointerUp(e){e.preventDefault();const t=e.target;t&&(t.releasePointerCapture(e.pointerId),t.removeEventListener("pointermove",this.boundOnResizePointerMove),this.cleanUpAfterResizeColumnComplete())}renderResizeForCell(e){return e[0]-1===this.getIndexOfLastVisibleColumn()?s``:s`<span class="cell-resize-handle"
     @pointerdown=${this.boundOnResizePointerDown}
     @pointerup=${this.boundOnResizePointerUp}
    ></span>`}getIndexOfLastVisibleColumn(){let e=this.columns.length-1;for(;e>-1;e--){if(this.columns[e].visible)break}return e}toggleColumnVisibility(e){const t=!e.visible,o=this.columns.map((o=>(o===e&&(o.visible=t),o)));this.data={...this.data,columns:o}}onHeaderContextMenu(t){if(2!==t.button)return;const o=new a.ContextMenu(t);for(const e of this.columns)e.hideable&&o.defaultSection().appendCheckboxItem(e.title,(()=>{this.toggleColumnVisibility(e)}),e.visible);const i=this.columns.filter((e=>!0===e.sortable));if(i.length>0){const t=o.defaultSection().appendSubMenuItem(e`Sort By`);for(const e of i)t.defaultSection().appendItem(e.title,(()=>{this.dispatchEvent(new y(e))}))}o.defaultSection().appendItem(e`Reset Columns`,(()=>{this.dispatchEvent(new Event("context-menu-header-reset-click"))})),this.contextMenus&&this.contextMenus.headerRow&&this.contextMenus.headerRow(o,this.columns),o.show()}render(){const e=this.columns.findIndex((e=>e.visible)),t=this.columns.some((e=>!0===e.sortable));l(s`
    <style>
      :host {
        --table-divider-color: var(--color-details-hairline);
        --toolbar-bg-color: var(--color-background-elevation-2);
        --selected-row-color: var(--color-background-elevation-1);

        height: 100%;
        display: block;
      }
      /* Ensure that vertically we don't overflow */
      .wrapping-container {
        overflow-y: scroll;
        /* Use max-height instead of height to ensure that the
           table does not use more space than necessary. */
        height: 100%;
        position: relative;
      }

      table {
        border-spacing: 0;
        width: 100%;
        height: 100%;
        /* To make sure that we properly hide overflowing text
           when horizontal space is too narrow. */
        table-layout: fixed;
      }

      tr {
        outline: none;
      }


      tbody tr {
        background-color: var(--color-background);
      }

      tbody tr.selected {
        background-color: var(--selected-row-color);
      }

      td, th {
        padding: 1px 4px;
        /* Divider between each cell, except the first one (see below) */
        border-left: 1px solid var(--table-divider-color);
        color: var(--color-text-primary);
        line-height: 18px;
        height: 18px;
        user-select: text;
        /* Ensure that text properly cuts off if horizontal space is too narrow */
        white-space: nowrap;
        text-overflow: ellipsis;
        overflow: hidden;
        position: relative;
      }

      .cell-resize-handle {
        right: 0;
        top: 0;
        height: 100%;
        width: 20px;
        cursor: col-resize;
        position: absolute;
      }

      /* There is no divider before the first cell */
      td.firstVisibleColumn, th.firstVisibleColumn {
        border-left: none;
      }

      th {
        font-weight: normal;
        text-align: left;
        border-bottom: 1px solid var(--table-divider-color);
        position: sticky;
        top: 0;
        z-index: 2;
        background-color: var(--toolbar-bg-color);
      }

      .hidden {
        display: none;
      }

      .filler-row td {
        /* By making the filler row cells 100% they take up any extra height,
         * leaving the cells with content to be the regular height, and the
         * final filler row to be as high as it needs to be to fill the empty
         * space.
         */
        height: 100%;
        pointer-events: none;
      }
      .filler-row td .cell-resize-handle {
        pointer-events: all;

      }

      [aria-sort]:hover {
        cursor: pointer;
      }

      [aria-sort="descending"]::after {
        content: " ";
        border-left: 0.3em solid transparent;
        border-right: 0.3em solid transparent;
        border-top: 0.3em solid black;
        position: absolute;
        right: 0.5em;
        top: 0.6em;
      }
      [aria-sort="ascending"]::after {
        content: " ";
        border-bottom: 0.3em solid black;
        border-left: 0.3em solid transparent;
        border-right: 0.3em solid transparent;
        position: absolute;
        right: 0.5em;
        top: 0.6em;
      }
    </style>
    <div class="wrapping-container">
      <table
        aria-rowcount=${this.rows.length}
        aria-colcount=${this.columns.length}
        @keydown=${this.onTableKeyDown}
      >
        <colgroup>
          ${this.columns.map(((e,t)=>{const o=`width: ${w(this.columns,e.id)}%`;return e.visible?s`<col style=${o} data-col-column-index=${t}>`:r}))}
        </colgroup>
        <thead>
          <tr @contextmenu=${this.onHeaderContextMenu}>
            ${this.columns.map(((o,i)=>{const r=n.classMap({hidden:!o.visible,firstVisibleColumn:i===e}),l=t&&i===this.focusableCell[0]&&0===this.focusableCell[1];return s`<th class=${r}
                data-grid-header-cell=${o.id}
                @click=${()=>{this.focusCell([i,0]),this.onColumnHeaderClick(o,i)}}
                title=${o.title}
                aria-sort=${n.ifDefined(this.ariaSortForHeader(o))}
                aria-colindex=${i+1}
                data-row-index='0'
                data-col-index=${i}
                tabindex=${n.ifDefined(t?l?"0":"-1":void 0)}
              >${o.title}${this.renderResizeForCell([i+1,0])}</th>`}))}
          </tr>
        </thead>
        <tbody>
          ${this.rows.map(((t,o)=>{const i=this.getCurrentlyFocusableCell(),[,r]=this.focusableCell,l=o+1,a=!!i&&(i===this.shadow.activeElement&&l===r),c=n.classMap({selected:a,hidden:!0===t.hidden});return s`
              <tr
                aria-rowindex=${o+1}
                class=${c}
              >${this.columns.map(((o,i)=>{const r=f(t,o.id),a=n.classMap({hidden:!o.visible,firstVisibleColumn:i===e}),c=i===this.focusableCell[0]&&l===this.focusableCell[1],h=p(r);return s`<td
                  class=${a}
                  title=${r.title||String(r.value)}
                  tabindex=${c?"0":"-1"}
                  aria-colindex=${i+1}
                  data-row-index=${l}
                  data-col-index=${i}
                  data-grid-value-cell-for-column=${o.id}
                  @focus=${()=>{this.dispatchEvent(new x(r,t))}}
                  @click=${()=>{this.focusCell([i,l])}}
                >${h}${this.renderResizeForCell([i+1,l])}</span></td>`}))}
            `}))}
         ${this.renderFillerRow()}
        </tbody>
      </table>
    </div>
    `,this.shadow,{eventContext:this}),this.scrollToBottomIfRequired(),this.hasRenderedAtLeastOnce=!0}}customElements.define("devtools-data-grid",R);var S=Object.freeze({__proto__:null,ColumnHeaderClickEvent:C,BodyCellFocusedEvent:x,ContextMenuColumnSortClickEvent:y,DataGrid:R});class $ extends HTMLElement{constructor(){super(...arguments),this.shadow=this.attachShadow({mode:"open"}),this.hasRenderedAtLeastOnce=!1,this.columns=[],this.rows=[],this.originalColumns=[],this.originalRows=[],this.sortState=null,this.filters=[]}get data(){return{columns:this.originalColumns,rows:this.originalRows,filters:this.filters,contextMenus:this.contextMenus}}set data(e){this.originalColumns=e.columns,this.originalRows=e.rows,this.filters=e.filters||[],this.contextMenus=e.contextMenus,this.columns=[...this.originalColumns],this.rows=this.cloneAndFilterRows(e.rows,this.filters),!this.hasRenderedAtLeastOnce&&e.initialSort&&(this.sortState=e.initialSort,this.sortRows(this.sortState)),this.render()}testRowWithFilter(e,t){let o=!1;const{key:i,text:s,negative:r,regex:n}=t;let l;if(i){const t=f(e,i);l=JSON.stringify(t.value).toLowerCase()}else l=JSON.stringify(e.cells.map((e=>e.value))).toLowerCase();return n?o=n.test(l):s&&(o=l.includes(s.toLowerCase())),r?!o:o}cloneAndFilterRows(e,t){return 0===t.length?[...e]:e.map((e=>{let o=!0;for(const i of t){if(!this.testRowWithFilter(e,i)){o=!1;break}}return{...e,hidden:!o}}))}sortRows(e){const{columnId:t,direction:o}=e;this.rows.sort(((e,i)=>{const s=f(e,t),r=f(i,t),n="number"==typeof s.value?s.value:String(s.value).toUpperCase(),l="number"==typeof r.value?r.value:String(r.value).toUpperCase();return n<l?"ASC"===o?-1:1:n>l?"ASC"===o?1:-1:0})),this.render()}onColumnHeaderClick(e){const{column:t}=e.data;this.applySortOnColumn(t)}applySortOnColumn(e){if(this.sortState&&this.sortState.columnId===e.id){const{columnId:e,direction:t}=this.sortState;this.sortState="DESC"===t?null:{columnId:e,direction:"DESC"}}else this.sortState={columnId:e.id,direction:"ASC"};this.sortState?this.sortRows(this.sortState):(this.rows=[...this.originalRows],this.render())}onContextMenuColumnSortClick(e){this.applySortOnColumn(e.data.column)}onContextMenuHeaderResetClick(){this.sortState=null,this.rows=[...this.originalRows],this.render()}render(){l(s`
      <style>
        :host {
          display: block;
          height: 100%;
          overflow: hidden;
        }
      </style>
      <devtools-data-grid .data=${{columns:this.columns,rows:this.rows,activeSort:this.sortState,contextMenus:this.contextMenus}}
        @column-header-click=${this.onColumnHeaderClick}
        @context-menu-column-sort-click=${this.onContextMenuColumnSortClick}
        @context-menu-header-reset-click=${this.onContextMenuHeaderResetClick}
     ></devtools-data-grid>
    `,this.shadow,{eventContext:this}),this.hasRenderedAtLeastOnce=!0}}customElements.define("devtools-data-grid-controller",$);var z=Object.freeze({__proto__:null,DataGridController:$});const M=e=>void 0!==e;class I extends HTMLElement{constructor(){super(...arguments),this.shadow=this.attachShadow({mode:"open"}),this.iconPath="",this.color="rgb(110 110 110)",this.width="100%",this.height="100%"}set data(e){const{width:t,height:o}=e;this.color=e.color,this.width=M(t)?t:M(o)?o:this.width,this.height=M(o)?o:M(t)?t:this.height,this.iconPath="iconPath"in e?e.iconPath:`Images/${e.iconName}.svg`,"iconName"in e&&(this.iconName=e.iconName),this.render()}get data(){const e={color:this.color,width:this.width,height:this.height};return this.iconName?{...e,iconName:this.iconName}:{...e,iconPath:this.iconPath}}getStyles(){const{iconPath:e,width:t,height:o,color:i}=this,s={width:t,height:o,display:"inline-block"};return i?{...s,webkitMaskImage:`url(${e})`,webkitMaskPosition:"center",webkitMaskRepeat:"no-repeat",webkitMaskSize:"100%",backgroundColor:`var(--icon-color, ${i})`}:{...s,backgroundImage:`url(${e})`,backgroundPosition:"center",backgroundRepeat:"no-repeat",backgroundSize:"100%"}}render(){l(s`
      <style>
        :host {
          display: inline-block;
          white-space: nowrap;
        }
      </style>
      <span class="icon-basic" style=${n.styleMap(this.getStyles())}></span>
    `,this.shadow)}}customElements.get("devtools-icon")||customElements.define("devtools-icon",I);var E=Object.freeze({__proto__:null,Icon:I});class L extends Event{constructor(e){super("linkifier-activated",{bubbles:!0,composed:!0}),this.data=e}}class P extends HTMLElement{constructor(){super(...arguments),this.shadow=this.attachShadow({mode:"open"}),this.url=""}set data(e){this.url=e.url,this.lineNumber=e.lineNumber,this.columnNumber=e.columnNumber,this.render()}onLinkActivation(e){e.preventDefault();const t=new L({url:this.url,lineNumber:this.lineNumber,columnNumber:this.columnNumber});this.dispatchEvent(t)}render(){if(!this.url)throw new Error("Cannot construct a Linkifier without providing a valid string URL.");return l(s`
      <style>
         .link:link, .link:visited {
            color: var(--color-link);
            text-decoration: underline;
            cursor: pointer;
         }
      </style>
      <a class="link" href=${this.url} @click=${this.onLinkActivation}>${function(e,t){if(e){let o=""+c.displayNameForURL(e);return void 0!==t&&(o+=":"+(t+1)),o}throw new Error("New linkifier component error: don't know how to generate link text for given arguments")}(this.url,this.lineNumber)}</a>
    `,this.shadow,{eventContext:this})}}customElements.define("devtools-linkifier",P);var A=Object.freeze({__proto__:null,LinkifierClick:L,Linkifier:P});class O extends HTMLElement{constructor(){super(...arguments),this.shadow=this.attachShadow({mode:"open"})}connectedCallback(){this.render()}render(){l(s`
      <style>
        .content {
          background-color:  var(--color-background);
          overflow: auto;
        }
      </style>

      <div class="content">
        <slot></slot>
      </div>
    `,this.shadow)}}class _ extends HTMLElement{constructor(){super(...arguments),this.shadow=this.attachShadow({mode:"open"}),this.sectionTitle=""}set data({sectionTitle:e}){this.sectionTitle=e,this.render()}render(){l(s`
      <style>
        .section {
          display: flex;
          padding: 12px;
          border-bottom: 1px solid var(--color-details-hairline);
          flex-direction: column;
        }

        .header {
          margin-left: 18px;
          display: flex;
          flex-direction: row;
          align-items: center;
          flex: auto;
          text-overflow: ellipsis;
          overflow: hidden;
          font-weight: bold;
          color: var(--color-text-primary);
        }
      </style>
      <div class="section">
        <div class="header">${this.sectionTitle}</div>
        <dl><slot></slot></dl>
      </div>
    `,this.shadow)}}class F extends HTMLElement{constructor(){super(...arguments),this.shadow=this.attachShadow({mode:"open"})}connectedCallback(){this.render()}render(){l(s`
      <style>
        :host {
          display: flex;
          line-height: 28px;
          margin: 8px 0px 0px 0px;
        }

        .name {
          color: var(--color-text-secondary);
          flex: 0 0 var(--name-column-width, 128px);
          padding: 0 6px;
          text-align: right;
          white-space: pre;
        }

        .value {
          color: var(--color-text-primary);
          flex: auto;
          margin-inline-start: 0px;
          padding: 0 6px;
          white-space: pre;
        }
      </style>
      <dt class="name"><slot name="name"></slot></dt>
      <dd class="value"><slot name="value"></slot></dd>
    `,this.shadow)}}customElements.define("devtools-report",O),customElements.define("devtools-report-section",_),customElements.define("devtools-report-row",F);var D=Object.freeze({__proto__:null,Report:O,ReportSection:_,ReportRow:F});export{S as DataGrid,z as DataGridController,d as DataGridRenderers,v as DataGridUtils,E as Icon,A as Linkifier,D as ReportView};
